/* pth-memory.c :  memmory layout in multiple thread program
   *author : xieqian
   *E-mail : xieqian@henu.edu.cn
   *To compile: gcc -o pth-memory pth-memory.c -lpthread
   */
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/mman.h>

pthread_t thread[2];
int number=1;

void *thread_local_ptr1, *thread_local_ptr2, *thread_local_ptr3;
void *code_ptr, *bss_ptr, *data_ptr;
void *heap_ptr, *mmap_ptr;

void *thread1()
{
        int test1;

	test1=number;
	thread_local_ptr1 = (void *) &test1;

        pthread_exit(NULL);
}

void *thread2()
{
        int test2;

	test2=number;
	thread_local_ptr2 = (void *) &test2;

        pthread_exit(NULL);
}

void thread_create(void)
{
         memset(&thread, 0, sizeof(thread));
         if(pthread_create(&thread[0], NULL, thread1, NULL) != 0)
                 printf("Fail to create thread 1.\n");
         else
                 printf("Thread 1 established.\n");

         if(pthread_create(&thread[1], NULL, thread2, NULL) != 0)
                 printf("Fail to create thread 2.\n");
         else
                 printf("Thread 2 established.\n");
}

void thread_wait(void)
{
         if(thread[0] !=0)
                 pthread_join(thread[0],NULL);
         if(thread[1] !=0)
                 pthread_join(thread[1],NULL);
}

int main()
{
	int x;
	
	thread_local_ptr3 = (void *)&x;
	code_ptr = (void *)&thread_wait;
	data_ptr = (void *)&number;
	bss_ptr = (void *)&code_ptr;
	heap_ptr = malloc(4);
	mmap_ptr = mmap(NULL, 4, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANON, -1, 0);
        printf("Try to demonstrate how the memory layout looks like in a multi-thread process.\n");
        thread_create();
        thread_wait();
	
	printf("\ncode: %x\n",(int)code_ptr);
	printf("data: %x\n",(int)data_ptr);
	printf("bss: %x\n",(int)bss_ptr);
	printf("heap: %x\n",(int)heap_ptr);
	printf("mmap: %x\n",(int)mmap_ptr);
	printf("thread1 stack: %x\n",(int)thread_local_ptr1);
	printf("thread2 stack: %x\n",(int)thread_local_ptr2);
	printf("main thread stack: %x\n",(int)thread_local_ptr3);

	scanf("%d", &x);
	free(heap_ptr);
	munmap(mmap_ptr,4);
        return 0;
}
